Page MenuHomePhabricator

Added button groups to WikiEditor toolbar do not appear after MW ResourceLoader update (English Wikisource)
Closed, ResolvedPublic

Description

With the update to Mediawiki this week, the ability for the additions of groups and maybe buttons has been reported at English Wikisource https://en.wikisource.org/wiki/Wikisource:Administrators%27_noticeboard#Special:Gadgets

For those using the Wikieditor toolbar it has now disabled all the extension's specific editing tools https://git.wikimedia.org/blob/mediawiki%2Fextensions%2FProofreadPage/HEAD/modules%2Fpage%2Fext.proofreadpage.page.edit.js thus making editing impossible in certain aspects.

Assistance is requested.
See https://en.wikisource.org/wiki/Wikisource:Administrators%27_noticeboard#Resource_Loader_issue_needs_outside_guidance

Event Timeline

Billinghurst updated the task description. (Show Details)
Billinghurst raised the priority of this task from to Needs Triage.
Billinghurst added a project: WikiEditor.
Billinghurst added subscribers: Billinghurst, Krinkle.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptAug 8 2015, 5:07 AM
Billinghurst set Security to None.
GOIII updated the task description. (Show Details)Aug 8 2015, 9:02 PM
GOIII updated the task description. (Show Details)
GOIII added a subscriber: Tpt.
GOIII added a subscriber: GOIII.
GOIII updated the task description. (Show Details)Aug 8 2015, 9:09 PM
AuFCL added a subscriber: AuFCL.Aug 9 2015, 12:31 AM
AuFCL added a comment.Aug 9 2015, 12:45 AM
This comment was removed by AuFCL.
jayvdb added a subscriber: jayvdb.Aug 9 2015, 2:17 AM
555 added a subscriber: 555.Aug 9 2015, 4:36 AM
TTO triaged this task as High priority.Aug 9 2015, 1:07 PM
Krenair added a subscriber: Krenair.Aug 9 2015, 1:34 PM
Aklapper renamed this task from Added button groups to Wikieditor toolbar failing to appear following MW update to Added button groups to WikiEditor toolbar do not appear after MW ResourceLoader update.Aug 13 2015, 12:43 PM
Mjbmr raised the priority of this task from High to Needs Triage.Aug 13 2015, 1:44 PM
Mjbmr edited projects, added Gadgets; removed ProofreadPage, Wikisource.
Billinghurst added a subscriber: Mjbmr.

@Mjbmr that wasn't polite, happy for you to add groups, but removing purposefully added groups :-(

@Mjbmr: How is this related to the code of the "Gadgets" MediaWiki extension (as you added that project)?

Mjbmr added a comment.EditedAug 13 2015, 3:57 PM

@Billinghurst See T108282 and T108939, we will have lots of tickets for every project, also If it's related to Wikisource, then it has to be related to all Wikisource projects.

@Aklapper Please do a research at least. see https://gerrit.wikimedia.org/r/230014/

@Mjbmr <sigh> please look at the the creation of the Wikisource group, it used to be the tracking bug. Your approach is contrary to the approach we have been taking.

The WS community has a clear goal to act cooperatively, not in isolation of each other. This bug is affecting our significant tool, and while reported by enWS will not be unique to it, and as such the resolution and its notification will be of a wider interest.

TheDJ added a subscriber: TheDJ.Aug 13 2015, 9:35 PM

Can we please get a more expansive and accurate problem description here ? Realize that not everyone knows how stuff is supposed to behave on wikisource and just saying "we got loads of problems" doesn't really give me or other people proper hooks to starting trying to help.

@TheDJ It is my understanding that where ProofreadPage extension is being utilised there is an additional group of tools made available from the extension using the componentry shown at the git link. So ...

IF there is a code change required to add buttons,

THEN the change needs to be made in ProofreadPage

ELSE, If there is a code change to be made to the wikieditor extension to resolve an issue then that is where the change should occur

ELSE if the problem lies with resource loader of other components, then it lies there.

So, the nub of the issue of why the group and buttons aren't showing needs to be identified first, before determining where the solution lies.

Tpt added a comment.Aug 14 2015, 1:40 AM

I don't manage to reproduce the issue when login in or out on latest version of Firefox and Safari.
Could you check if the root cause of the error is not one of your user script/gadget by clearing your personal common.js and vector.js and opting out to all gadgets and then enable them back one by one?

I will report that back to the community. [I am having no issues with the old toolbar.]

Billinghurst changed the task status from Open to Stalled.Aug 14 2015, 2:33 AM

Putting to stalled while community looks to further identify the issue.

Conversation back to the community relaying above commentary
https://en.wikisource.org/w/index.php?title=Specia:Diff/5577558

Mjbmr added a comment.Aug 14 2015, 8:13 AM

@Billinghurst I'm not sure why @Aklapper don't speak up, keep saying I'm not aware of what happened to MediaWiki, and I'm adding unrelated tags, while you say don't remove unrelated tag and calling me rude, instead of working to solve the problem.

Aklapper added a subscriber: Qgil.Aug 14 2015, 3:59 PM

[offtopic]

@Aklapper Please do a research at least.

@Mjbmr: My question to you was "How is this related to the code of the "Gadgets" MediaWiki extension". The wording of your answer comes across as unneededly derogative. I'd appreciate if people assumed that people mean well. I simply cannot look up all code changes in all places for every single task I look at, so I asked you for explanation. The link itself that you provided is helpful, thanks for that. If you were "called rude", please provide the quote and link where this happened and I'm happy to look into that as part of the Phabricator etiquette. And "working to solve the problem" is as much your responsibility as it is mine and everybody else's in this community.
Regarding your last comment, https://phabricator.wikimedia.org/project/profile/1117/ explains how the Wikisource project is supposed to be used and how it is not supposed to be used. But that is a meta-discussion not meant for this specific ticket... :)

Mjbmr added a comment.Aug 14 2015, 9:48 PM

@Aklapper Good luck with whatever you trying to be.

Mjbmr renamed this task from Added button groups to WikiEditor toolbar do not appear after MW ResourceLoader update to Added button groups to WikiEditor toolbar do not appear after MW ResourceLoader update (English Wikisource).Aug 14 2015, 9:49 PM

With regards the comment above at no point to the best of my knowledge was the old ("legacy"?) toolbar affected.

This issue has evolved through several distinct issues. It initially manifested itself as javascript errors presenting on end-user browsers (yep: mostly ignored) which indicated ResourceLoader misconfiguration pointing to a need to fix items on Special:Gadgets.

When eventually addressed this "fixed" the missing ProofreaderPage items on the "advanced" toolbar. One single hold-out user was then revealed to have toolbar button and colour issues only when using the Chrome browser. After a multi-day diversion (possibly destined to come out in book form one day?) now seems at last happy again.

This is my perspective untainted by community consultation or feedback.

Mjbmr added a comment.Aug 16 2015, 6:55 AM

Calling final WikiEditor modifier with $(document).ready would work.

AuFCL added a comment.EditedAug 17 2015, 6:57 AM

Calling final WikiEditor modifier with $(document).ready would work.

Please expand upon this.

As certain gadgets (e.g. Gadget-ocr.js‎‎) "build" their activation button into WikiEditor; as do user-defined button sets and indeed Vector itself, presumably each entity invoking $(document).ready simply defers the same race-conditions from one point in time to another? (I am assuming all three—or however many—code sets are all queuing on .ready, if that is what you really meant?)

(I can see an inkling of an answer here but expect I'm missing an important point? In particular I am unclear how one determines the "final modifier.")

TheDJ added a comment.Aug 17 2015, 8:29 AM

Perhaps part of what is going wrong here is that indeed, everything is just piling up on document.ready (be it the proofread extension or a gadget), but actually require order in order to accurately perform their functionality. Order which is not enforced and thus leads to race conditions, with varying results at varying times.

I think it would be good if some authors read the entire documentation page on doing toolbar customization, and especially the part on modifying.
https://www.mediawiki.org/wiki/Extension:WikiEditor/Toolbar_customization#Modifying_things

But I'm still not rly clear on what kind of problems wikisource is experiencing, so I can't be sure that is the right advise..

AuFCL added a comment.Aug 17 2015, 9:44 AM

I think it would be good if some authors read the entire documentation page on doing toolbar customization, and especially the part on modifying.
https://www.mediawiki.org/wiki/Extension:WikiEditor/Toolbar_customization#Modifying_things

But I'm still not rly clear on what kind of problems wikisource is experiencing, so I can't be sure that is the right advise..

Good reference and I thank you for it. I had already read the page referred to but had not specifically noted that particular point. I can confirm the users are not doing that at all; this being a typical code fragment:

 		$.when(
				mw.loader.using( ['ext.wikiEditor.toolbar'] ),
				$.ready
			).then( customizeToolbar );

Regarding "the right advise" at this point things appear to have stabilised and nobody is admitting to still having problems. This last diversion might be considered my earnest attempt to draw as many lessons as possible pending the next time this sort of thing happens. (Surely I am not the only one who expects that?)

Restricted Application added a subscriber: StudiesWorld. · View Herald TranscriptNov 12 2015, 11:07 PM

Can this task be closed now?

Can this task be closed now?

Gets my support. This is effectively the question I asked three months ago. Pretty much all the relevant links have auto-expired (O.K. "been archived") in any case. Apparent total disinterest?

Jdforrester-WMF closed this task as Resolved.Nov 12 2015, 11:31 PM
Jdforrester-WMF claimed this task.
Aschroet removed a subscriber: Aschroet.Nov 13 2015, 4:19 AM
GOIII moved this task from Backlog to Closed on the WikiEditor board.Apr 3 2016, 9:04 AM
Restricted Application removed a subscriber: Mjbmr. · View Herald TranscriptApr 3 2016, 9:04 AM
AuFCL removed a subscriber: AuFCL.Nov 21 2016, 7:38 PM